"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = DevTools;
var _react = _interopRequireDefault(require("react"));
var _jotai = require("jotai");
var _global = require("./state/global");
var _devToolsCollapsed = _interopRequireDefault(require("./dev-tools-collapsed"));
var _devToolsExpanded = _interopRequireDefault(require("./dev-tools-expanded"));
var _useResizeDocument = require("./hooks/use-resize-document");
var _useSubscribeToEditorView = require("./hooks/use-subscribe-to-editor-view");
var _useRollbackHistory = require("./hooks/use-rollback-history");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function DevTools(props) {
  var _useAtom = (0, _jotai.useAtom)(_global.devToolsOpenedAtom),
    _useAtom2 = _slicedToArray(_useAtom, 2),
    isOpen = _useAtom2[0],
    setIsOpen = _useAtom2[1];
  var defaultSize = (0, _jotai.useAtomValue)(_global.devToolsSizeAtom);
  var editorView = props.editorView;
  var toggleOpen = _react["default"].useCallback(function () {
    return setIsOpen(!isOpen);
  }, [isOpen]);
  (0, _useResizeDocument.useResizeDocument)(isOpen, defaultSize);
  (0, _useSubscribeToEditorView.useSubscribeToEditorView)(editorView, props.diffWorker);
  var rollbackHistory = (0, _useRollbackHistory.useRollbackHistory)(editorView);
  if (isOpen) {
    return /*#__PURE__*/_react["default"].createElement(_devToolsExpanded["default"], {
      rollbackHistory: rollbackHistory
    });
  }
  return /*#__PURE__*/_react["default"].createElement(_devToolsCollapsed["default"], {
    onClick: toggleOpen
  });
}