"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useRollbackHistory = useRollbackHistory;
var _react = _interopRequireDefault(require("react"));
var _jotai = require("jotai");
var _prosemirrorState = require("prosemirror-state");
var _editorState = require("../state/editor-state");
var _history = require("../state/history");
var _getEditorState = _interopRequireDefault(require("../state/get-editor-state"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function useRollbackHistory(editorView) {
  var setHistoryRolledBackTo = (0, _jotai.useSetAtom)(_history.historyRolledBackToAtom);
  var setEditorState = (0, _jotai.useSetAtom)(_editorState.editorStateAtom);
  var rollbackHistory = _react["default"].useCallback(function (historyItem, historyItemIndex) {
    var EditorState = (0, _getEditorState["default"])();
    var state = historyItem.state;
    var newState = EditorState.create({
      schema: state.schema,
      plugins: state.plugins,
      doc: state.schema.nodeFromJSON(state.doc.toJSON())
    });
    editorView.updateState(newState);
    editorView.dom.focus();
    var selection = _prosemirrorState.Selection.fromJSON(editorView.state.doc, state.selection.toJSON());
    var tr = editorView.state.tr.setSelection(selection).setMeta("addToHistory", false).setMeta("_skip-dev-tools-history_", true);
    editorView.dispatch(tr);
    setEditorState(editorView.state);
    setHistoryRolledBackTo(historyItemIndex);
  }, [editorView]);
  return rollbackHistory;
}