"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.activeMarksAtom = void 0;
var _jotai = require("jotai");
var _editorState = require("./editor-state");
var activeMarksAtom = (0, _jotai.atom)(function (get) {
  var editorState = get(_editorState.editorStateAtom);
  if (!editorState) return [];
  return getActiveMarks(editorState);
});
exports.activeMarksAtom = activeMarksAtom;
function getActiveMarks(editorState) {
  var selection = editorState.selection;
  var marks = [];
  if (selection.empty) {
    marks = selection.$from.marks();
  } else {
    editorState.doc.nodesBetween(selection.from, selection.to, function (node) {
      marks = marks.concat(node.marks);
    });
  }
  return marks.reduce(function (acc, mark) {
    if (acc.indexOf(mark) === -1) {
      acc.push(mark);
    }
    return acc;
  }, []).map(function (m) {
    return m.toJSON();
  });
}