"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PluginState = PluginState;
exports["default"] = PluginsTab;
exports.valueRenderer = valueRenderer;
var _react = _interopRequireWildcard(require("react"));
var _infoPanel = require("../components/info-panel");
var _heading = require("../components/heading");
var _jsonTree = _interopRequireDefault(require("../components/json-tree"));
var _list = require("../components/list");
var _splitView = require("../components/split-view");
var _jotai = require("jotai");
var _editorState = require("../state/editor-state");
var _searchBar = _interopRequireDefault(require("../components/search-bar"));
var _button = _interopRequireDefault(require("../components/button"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function valueRenderer(raw) {
  if (typeof (arguments.length <= 1 ? undefined : arguments[1]) === "function") {
    return "func";
  }
  return raw;
}
function PluginState(props) {
  return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_heading.Heading, null, "Plugin State"), /*#__PURE__*/_react["default"].createElement(_jsonTree["default"], {
    data: props.pluginState,
    valueRenderer: valueRenderer,
    sortObjectKeys: true
  }));
}

// TODO: replace isDimmed with useCallback once EditorStateContainer is decomposed
function PluginsTab() {
  var state = (0, _jotai.useAtomValue)(_editorState.editorStateAtom);
  if (!state) return null;
  var _useState = (0, _react.useState)(state.plugins[0]),
    _useState2 = _slicedToArray(_useState, 2),
    selectedPlugin = _useState2[0],
    setSelectedPlugin = _useState2[1];
  var _useState3 = (0, _react.useState)(state.plugins),
    _useState4 = _slicedToArray(_useState3, 2),
    pluginsLocal = _useState4[0],
    setPluginsLocal = _useState4[1];
  var _useState5 = (0, _react.useState)(true),
    _useState6 = _slicedToArray(_useState5, 2),
    sortAsc = _useState6[0],
    setSortOrder = _useState6[1];
  var handleOnListItemClick = _react["default"].useCallback(function (_plugin) {
    return setSelectedPlugin(_plugin);
  }, []);
  var selectedPluginState = selectedPlugin.getState(state);
  var handleSearch = (0, _react.useCallback)(function (input) {
    var filteredPlugins = state.plugins.filter(function (plugin) {
      return plugin.key.toLowerCase().includes(input.toLowerCase());
    });
    setPluginsLocal(filteredPlugins);
  }, [state.plugins]);
  var handleClickSort = function handleClickSort() {
    setSortOrder(!sortAsc);
  };
  var handleSortAsc = function handleSortAsc(plugins) {
    return _toConsumableArray(plugins).sort(function (a, b) {
      if (a.key < b.key) {
        return -1;
      }
      if (a.key > b.key) {
        return 1;
      }
      return 0;
    });
  };
  var handleSortDes = function handleSortDes(plugins) {
    return _toConsumableArray(plugins).sort(function (a, b) {
      if (a.key < b.key) {
        return 1;
      }
      if (a.key > b.key) {
        return -1;
      }
      return 0;
    });
  };
  return /*#__PURE__*/_react["default"].createElement(_splitView.SplitView, {
    testId: "__prosemirror_devtools_tabs_plugins__"
  }, /*#__PURE__*/_react["default"].createElement(_splitView.SplitViewCol, {
    noPaddings: true
  }, /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      display: "flex",
      marginLeft: 6,
      marginRight: 6,
      marginBottom: 3,
      marginTop: 3
    }
  }, /*#__PURE__*/_react["default"].createElement(_searchBar["default"], {
    onSearch: handleSearch
  }), /*#__PURE__*/_react["default"].createElement(_button["default"], {
    onClick: handleClickSort
  }, "SORT ", sortAsc ? "DES" : "ASC")), /*#__PURE__*/_react["default"].createElement(_list.List, {
    items: sortAsc ? handleSortAsc(pluginsLocal) : handleSortDes(pluginsLocal),
    getKey: function getKey(plugin) {
      return plugin.key;
    },
    title: function title(plugin) {
      return plugin.key;
    },
    isDimmed: function isDimmed(plugin) {
      return !plugin.getState(state);
    },
    onListItemClick: handleOnListItemClick
  })), /*#__PURE__*/_react["default"].createElement(_splitView.SplitViewCol, {
    grow: true,
    sep: true
  }, selectedPluginState ? /*#__PURE__*/_react["default"].createElement(PluginState, {
    pluginState: selectedPluginState
  }) : /*#__PURE__*/_react["default"].createElement(_infoPanel.InfoPanel, null, "Plugin doesn't have any state")));
}